/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.controller;

import cn.hutool.core.util.ArrayUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.system.expand.feign.IConfClient;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.estate.entity.WorkOrder;
import org.springblade.estate.vo.WorkOrderVO;
import org.springblade.estate.wrapper.WorkOrderWrapper;
import org.springblade.estate.service.IWorkOrderService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-12-28
 */
@RestController
@AllArgsConstructor
@RequestMapping("/workorder")
@Api(value = "", tags = "接口")
public class WorkOrderController extends BladeController {

	private final IWorkOrderService workOrderService;
	private final IConfClient confClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入workOrder")
	public R<WorkOrderVO> detail(WorkOrder workOrder) {
		WorkOrder detail = workOrderService.getOne(Condition.getQueryWrapper(workOrder));
		return R.data(WorkOrderWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入workOrder")
	public R<IPage<WorkOrderVO>> list(WorkOrder workOrder, Query query) {
		IPage<WorkOrder> pages = workOrderService.page(Condition.getPage(query), Condition.getQueryWrapper(workOrder));
		return R.data(WorkOrderWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入workOrder")
	public R<IPage<WorkOrderVO>> page(WorkOrderVO workOrder, Query query) {
		IPage<WorkOrderVO> pages = workOrderService.selectWorkOrderPage(Condition.getPage(query), workOrder);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入workOrder")
	public R save(@Valid @RequestBody WorkOrder workOrder) {
		return R.status(workOrderService.save(workOrder));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入workOrder")
	public R update(@Valid @RequestBody WorkOrder workOrder) {
		return R.status(workOrderService.updateById(workOrder));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入workOrder")
	public R submit(@Valid @RequestBody WorkOrder workOrder) {
		workOrder.setHandleStatus(0);
		if(StringUtil.isNotBlank(workOrder.getImg())){
			List<String> stringList = Func.toStrList(workOrder.getImg());
			List<String> saveList = new ArrayList<>();
			for (String img : stringList){
				saveList.add(confClient.removePrefix(img));
			}
			if(saveList.size() > 0){
				String imgs = saveList.stream().map(String::valueOf).collect(Collectors.joining(","));
				workOrder.setImg(imgs);
			}
		}
		return R.status(workOrderService.saveOrUpdate(workOrder));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(workOrderService.deleteLogic(Func.toLongList(ids)));
	}


}
